; ShortCut v0.4
; (C) 2003 Andy Janata.
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

; Portions of code based on or copied from
; Omnicalc v1.00 and/or v1.10
; (C) 2002-2003 Michael Vincent.
; michael@detachedsolutions.com
; Omnicalc was published under the GNU General Public License.

; Portions of code based on or copied from
; Unit Operations v0.6
; (C) 2003 Benjamin Moody
; benjamin@ecg.mit.edu
; Unit Opeations was published under the GNU General Public License.

; ShortCut v0.4
; Andy Janata - andysoft_ltd@hotmail.com
; Project started 11/03/03.


 NOLIST
 INCLUDE "equates.inc"
 LIST
 GLOBALS ON
 INCLUDE "header.inc"

TopOApp:
    set appAutoScroll,(IY + appFlags)       ; automatically scroll the screen.

    
;;;;;;;;;;; I shouldn't need this anymore since I put the minimum basecode field in the App header    
;    b_call GetBaseVer
;    ld a,b
;    cp 0Fh      ; we need OS 1.15 to have support for the keyboard to begin with!
;    jr nc,osVerOK   ; if there is a carry, that means that the minor is < 15d
;    call ClrScrn
;    InvOn
;    Echo textError
;    InvOff
;    Echo badOSVer
;    b_call GetKey
;    call ClrScrn
;    b_jump JForceCmdNoChar
;osVerOK:


;    call LoadAppVar_Main       ; i was thinking, and I dont need an AppVar right now
drawMenu:                   ; I think a label for this is good, since I'm using osVerOK to repaint the menu
    call ClrScrn
    InvOn
    Echo mainMenu
    InvOff
    Echo mainMenu2
    xor a               ; these lines serve a useful purpose, so let them be.
    ld (ek1),a
    ld (ek2),a
    ld (ek3),a
    ld (ek4),a

mainMenuLoop:
    b_call GetKey
    call Eggy1
    cp k1
    jr z,menuInstall
    cp k2
    jr z,menuUninstall
    cp k3
    jr z,menuInfo
    cp k4
    jp z,EndOApp
    cp kQuit
    jp z,EndOApp
    cp kClear
    jp z,EndOApp
    jr mainMenuLoop
menuInstall:
    call InstallRawKeyHook
    jr drawMenu
menuUninstall:
    call ClrScrn
    InvOn
    Echo menuTitle
    InvOff
    b_call DisableRawKeyHook
    res keybReportAll,(iy+keybFlags)
    Echo hookText
    Echo hookUnInstalled
    b_call NewLine
    Echo pressKey
    b_call GetKey
    jp drawMenu
menuInfo:
    call ClrScrn
    InvOn
    Echo menuTitle
    InvOff
    Echo infoMenu

infoMenuLoop:
    b_call GetKey
    cp k1
    jr z,infoAbout
    cp k2
    jr z,infoThanks
    cp k3
    jr z,infoHelp
    cp k4
    jp z,drawMenu
    cp kQuit
    jr z,EndOApp
    cp kClear
    jr z,EndOApp
    jr infoMenuLoop
infoAbout:
    call ClrScrn
    InvOn
    Echo menuTitle
    InvOff
    Echo textAbout
    Echo pressKey
    b_call GetKey
    jp drawMenu
infoThanks:
    call ClrScrn
    ld hl,textThanks
    call scrollText
    b_call GetKey
    res onInterrupt,(iy+onFlags)        ; kill the ON key flag
    jp drawMenu
infoHelp:
    call ClrScrn
    InvOn
    Echo menuTitle
    InvOff
    Echo textHelp
    Echo pressKey
    b_call GetKey
    jp drawMenu


EndOApp:
    call ClrScrn

;    di         ; to get the debugger to stop
;    halt

    b_jump JForceCmdNoChar

 INCLUDE "rawkeyhook.inc"
 INCLUDE "subroutines.inc"

; data follows

; data for the AppVar
; not used now, but this and the code are still in here -- just never used
appVarName:
    db AppVarObj,"SCutConf"
appVarDef:
appVarSig:
    db "SCut"
appVarSigLen EQU $-appVarSig
	;; byte 1:
	;;    bit 0: installed
	db	0
	;; future: have it store other apps to chain, and stuff for something
	;;    like a custom omnicalc config or something. we really just need 1 bit :)
appVarDefLen EQU $-appVarDef

; end AppVar data
; data for the interface

; for the keyhook installer
hookText:
    db "Hook "
    db 0
hookExists:
    db "exists.", 0D6h
    db "Overwrite?", 0D6h
    db 0D6h
    db "1) Yes", 0D6h
    db "2) No"
    db 0
hookUnInstalled:
    db 0D6h
    db "un"
hookInstalled:
    db "installed."
    db 0
pressKey:
    db " Press any key",fElipsis
    db 0
notInstalled:
    db "Did not install."
    db 0

; menu
menuTitle:
mainMenu:       ; also used as a header
    ;   0123456789ABCDEF
    db "  ShortCut v0.4 "
    db " by Andy Janata "
    db 0D6h, 0
mainMenu2:
    db 0D6h
    db "1) Install", 0D6h
    db "2) Uninstall", 0D6h
    db "3) Information",fElipsis, 0D6h          ; 15 chars
    db "4) Quit"
    db 0

;;;;;;; I shouldn't need the basecode check now that I put it into the App header    
; bad OS ver
;textError:
;    ;   0123456789ABCDEF
;    db "     ERROR!     "
;    db 0
;badOSVer:
;    db 0D6h
;    db "You must have OS"
;    db "1.15 or higher", 0D6h
;    db "to run ShortCut."
;    db 0D6h
;    db 0

; info
infoMenu:
    db 0D6h
    db "1) About",0D6h
    db "2) Thanks to",fElipsis,0D6h
    db "3) Help!",0D6h
    db "4) Main Menu"
    db 0
; about
textAbout:
  ; start with the menuTitle text
    ;   0123456789ABCDEF
    db "http://ajj.cjb",0D6h
    db "  .net/",0D6h
    db "andysoft_ltd@",0D6h
    db "  hotmail.com",0D6h
    db 0
  ; now the Press Any Key
textThanks:
  ; scrolled using the easter egg method
    ;   0123456789ABCDEF
    db "  ShortCut v0.4 ",0
    db " by Andy Janata ",0
    db 0D6h,0
    db "Special thanks",0D6h,0
    db "goes out to:",0D6h,0
    db 0D6h,0
    db "-JMan for moral",0D6h,0
    db "support and",0D6h,0
    db "looking over it.",0         ; 16 chars
    db 0D6h,0
    db "-Michael Vincent",0         ; 16 chars
    db "for making",0D6h,0
    db "Omnicalc.",0D6h,0
    db 0D6h,0
    db "-The rest of",0D6h,0
    db "Detached",0D6h,0
    db "Solutions for",0D6h,0
    db "finding the",0D6h,0
    db "hooks to begin",0D6h,0
    db "with.",0D6h,0
    db 0D6h,0
    db "-The rest of the",0         ; 16 chars
    db "people on the DS",0         ; 16 chars
    db "Forum for help",0D6h,0
    db "and insight.",0D6h,0
    db 0D6h,0
    db "-Everyone in",0D6h,0
    db "#TCPA on EFNet",0D6h,0
    db "who's ever",0D6h,0
    db "helped me --",0D6h,0
    db "heck, even those",0         ; 16 chars
    db "who haven't",0D6h,0
    db "helped me should",0         ; 16 chars
    db "be thanked just",0D6h,0
    db "for being there.",0         ; 16 chars
    db 0D6h,0
    db "-A friend at",0D6h,0
    db "school (Nick",0D6h,0
    db "Schott) for",0D6h,0
    db "putting up",0D6h,0
    db "with my constant",0         ; 16 chars
    db "blabbing about",0D6h,0
    db "this at lunch",0D6h,0
    db "and for moral",0D6h,0
    db "support. On",0D6h,0
    db "second thought,",0D6h,0
    db "I ought to thank",0         ; 16 chars
    db "everyone at my",0D6h,0
    db "lunch table for",0D6h,0
    db "putting up with",0D6h,0
    db "my talking,",0D6h,0
    db "especially since",0         ; 16 chars
    db "most of what I",0D6h,0
    db "say about to",0D6h,0
    db "electronics is",0D6h,0
    db "over their",0D6h,0
    db "heads.",0D6h,0
    db 0D6h
    db "(Press any key)",0
    db 0FFh

textHelp:
    db "Not yet. :("
    db 0D6h,0D6h,0


 INCLUDE "easteregg.inc"
    ; ^^ the easter egg file

 INCLUDE "keymap.inc"
    ; ^^ has the key mappings in it

 INCLUDE "help.inc"
    ; ^^ the help 'system'
