; ShortCut v0.4
; (C) 2003 Andy Janata.
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
; In-App Help file - code to show and the text for it

; variables for current text pointer, etc
helpPage        EQU     saveSScreen


helpMain:
    ; the main help area - initialize the variables, etc
    ld a,1
    ld (helpPage),a
    res appAutoScroll,(IY + appFlags)       ; don't automatically scroll the screen.


    ld hl,(helpPage1)
    call helpShowScreen
    b_call GetKey



    set appAutoScroll,(IY + appFlags)       ; automatically scroll the screen.
    ret



helpShowScreen:
        ;; this just shows the screen, doesn't handle keypresses
        ;; although it does check what scrollbar stuff to show
        ;; the text address should be in HL, exactly 128d bytes, no termination
    xor a
    ld (curRow),a       ; top-left
    ld (curCol),a
    ld b,128-16
helpShowScreen_Loop:
    ld a,(hl)
    b_call PutC
    inc hl
    djnz helpShowScreen_Loop        ; show all the text at once
    ld a,(helpPage)
    cp 1
    jr z,helpShowScreen_NoUpArrow
    ld a,0Fh
    ld (curCol),a                   ; top-right
    xor a
    ld (curRow),a
    ld a,fUp
    b_call PutC
helpShowScreen_NoUpArrow:
    ld b,6                          ; 6 lines for the shaded scrollbar
    ld d,1                          ; used for curRow
helpShowScreen_ScrollbarLoop:
    ld a,d
    ld (curRow),a
    ld a,0Fh
    ld (curCol),a
    ld a,fCheckerBlock
    b_call PutC
    inc d
    djnz helpShowScreen_ScrollbarLoop
    ld a,(helpPage)
    cp 7
    jr z,helpShowScreen_NoDownArrow
    ld a,0Fh
    ld (curCol),a                   ; bottom-right
    ld a,8
    ld (curRow),a
    ld a,fDown
    b_call PutC
helpShowScreen_NoDownArrow:
        ;; now to put the solid box for the scrollbar
    ld a,(helpPage)
    cp 5                    ; 1-4 in row 1+page. 5-7 in row page, 8-12 in row 7
    jr nc,helpShowScreen_NoAdjustScroll_1
    inc a
helpShowScreen_NoAdjustScroll_1:
    cp 8
    jr c,helpShowScreen_NoAdjustScroll_2
    ld a,7
helpShowScreen_NoAdjustScroll_2:
    ld (curRow),a
    ld a,0Fh
    ld (curCol),a
    ld a,fSolidBlock
    b_call PutC
    ret
        ;; finally done!




fUp              EQU     01Eh     ; up arrow
fDown            EQU     01Fh     ; down arrow
fSolidBlock      EQU     0E0h     ; solid block (scroll box)
fCheckerBlock    EQU     0F1h     ; checkered block (mem full) (scrollbar)

;;;;;;;; Keep the rightmost column free for scrollbar

;; make it *think* (that is, show on the scrollbar) it only has 7 pages
;;  (there are 12)

helpPage1:
    ;   0123456789ABCDEF
    db " Help Contents  "
    db "-Installation   "
    db "-Usage          "
    db "*************** "
    db "Press CLEAR to  "
    db "quit the help.  "
    db "*************** "
    db "                "
helpPage2:
    ;   0123456789ABCDEF
    db "Installation    "
    db "Select Install  "
    db "from the Main   "
    db "Menu. If some   "
    db "other App has   "
    db "the hook needed "
    db "(like OmniCalc) "
    db "it will ask if  "
helpPage3:
    ;   0123456789ABCDEF
    db "you want to     "
    db "overwrite that  "
    db "hook. I hope to "
    db "add chaining    "
    db "soon. To unin-  "
    db "stall, choose   "
    db "Uninstall from  "
    db "the menu or you "
helpPage4:
    ;   0123456789ABCDEF
    db "can reset your  "
    db "RAM or install  "
    db "another hooking "
    db "App.            "
    db "*************** "
    db "Usage           "
    db "Just press any  "
    db "key that is     "
helpPage5:
    ;   0123456789ABCDEF
    db "remapped and it "
    db "will act like   "
    db "whatever it is  "
    db "remapped to was "
    db "pressed (for    "
    db "the most part). "
    db "This is very    "
    db "useful if you   "
helpPage6:
    ;   0123456789ABCDEF
    db "have a TI Key-  "
    db "board since the "
    db "OS only gives   "
    db "you a few extra "
    db "keys on the     "
    db "home screen.    "
    db "For a complete  "
    db "key remap list  "
helpPage7:
    ;   0123456789ABCDEF
    db "please see the  "
    db "readme file in  "
    db "the ZIP file.   "
    db "*************** "
    db "That's it for   "
    db "the online      "
    db "help. Have fun! "
    db "                "
helpPage8:
    ;   0123456789ABCDEF
    db "OK, you went    "
    db "past the end... "
    db "What do you ex- "
    db "pect, a list of "
    db "all the Easter  "
    db "Eggs? It ain't  "
    db "happening!      "
    db "Press CLEAR.    "
helpPage9:
    ;   0123456789ABCDEF
    db "You ARE persis- "
    db "tant aren't     "
    db "you? If you     "
    db "press down      "
    db "again I'll re-  "
    db "set your RAM.   "
    db "Not really...   "
    db "PRESS CLEAR!!!! "
helpPage10:
    ;   0123456789ABCDEF
    db "                "
    db "                "
    db "                "
    db "                "
    db "                "
    db "                "
    db "                "
    db "                "
helpPage11:
    ;   0123456789ABCDEF
    db "OK, so I did    "
    db "put an Easter   "
    db "Egg list here.  "
    db "Other than this "
    db "Help Egg, enter "
    db "the key sequen- "
    db "ces on the next "
    db "page in the     "
helpPage12:
    ;   0123456789ABCDEF
    db "Menu:           "
    db "(You have to    "
    db "do them to see  "
    db "what happens!)  "
    db "TAKUYA   NX-01  "
    db fPI,"?    GUILMON   "        ; 16 chars
    db "That's it for   "
    db "now. THE END!!! "

