; ShortCut v0.7
; (C) 2003-2004 Andy Janata.
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
; Key Mapping file - this has the table for values to re-map.

;;;;;;;; SPECIAL KEYS -- handled differently
; edit these to change what key does the APD
keyForAPD_Acc           EQU     kGROUP3
keyForAPD_Extend        EQU     kSqrBkSpace

;keyForAPD_Acc           EQU     k3
;keyForAPD_Extend        EQU     0

; edit these to change what key increases the contrast
keyForContrUp_Acc       EQU     kGROUP3
keyForContrUp_Extend    EQU     kSqrUp
; edit these to change what key decreases the contrast
keyForContrDn_Acc       EQU     kGROUP3
keyForContrDn_Extend    EQU     kSqrDn
; edit these to change what key enters lower-case accented mode
; this also does knTilde
; this also does inverted ? and !
keyForLAccent_Acc       EQU     kGROUP3
keyForLAccent_Extend    EQU     kSqrQuote
; edit these to change what key enters capital accented mode
; this also does kcapNTilde
; this also does inverted ? and !
keyForCAccent_Acc       EQU     kGROUP3
keyForCAccent_Extend    EQU     kSqrTilde

;;;;;;;; NORMAL KEYS -- handled with a loop
; format:  db <in_acc>,<in_keyExtend>,<out_acc>,<out_keyExtend>
; example: db kGROUP3,kDiaQ,kQuit,0
; each entry MUST have 4 bytes!!! pad with a 0 if needed

keyMappings:
    ; PART ONE: THE STANDARD OS KEYS
    ; all of them use the <> diamond key
    db kGROUP3,kDiaTilde,kAppsMenu,0            ; ~ => APPS
    db kGROUP3,kDia1,kYequ,0                    ; 1 => Y=
    db kGROUP3,kDia2,kWindow,0                  ; 2 => WINDOW
    db kGROUP3,kDia3,kZoom,0                    ; 3 => ZOOM
    db kGROUP3,kDia4,kTrace,0                   ; 4 => TRACE
    db kGROUP3,kDia5,kGraph,0                   ; 5 => GRAPH
    db kGROUP3,kDiaSub,kNegate,0                ; - => (-)      [minus => negate]
    db kGROUP3,kDiaEquals,kExtendEcho,kTNoteQ   ; = => !=       note weird caps
    db kGROUP3,kDiaBkSpace,kClear,0             ; backspace => clear
    db kGROUP3,kTab,kSpace,0                    ; tab => space
    db kGROUP3,kDiaQ,kQuit,0                    ; q => [QUIT]
    db kGROUP3,kDiaQuote,kCatalog,0             ; ' => [CATALOG]
    db kGROUP3,kDiaComma,kExtendEcho,kTLTE      ; , => <=
    db kGROUP3,kDiaPeriod,kExtendEcho,kTGTE     ; . => >=
    db kGROUP3,kDiaDel,kIns,0                   ; DEL => [INS]
    db kGROUP3,kDiaLeft,kBOL,0                  ; <- => home (2nd+left)
    db kGROUP3,kDiaRight,kEOL,0                 ; -> => end  (2nd+right)


    ; PART TWO: OUR CUSTOM DIAMOND KEYS
    ; I arbitrarily picked (most of) the remaining <> keys to be the menu keys
    db kGROUP3,kDia6,kSPlot,0           ; 6 => [STAT PLOT]
    db kGROUP3,kDia7,kTblSet,0          ; 7 => [TBLSET]
    db kGROUP3,kDia8,kFormat,0          ; 8 => [FORMAT]    
    db kGROUP3,kDia9,kCalc,0            ; 9 => [CALC]
    db kGROUP3,kDia0,kTable,0           ; 0 => [TABLE]
    db kGROUP3,kDiaTab,kStore,0         ; tab => STO>

    ;;;;;; I'm trying to make these based on the first letter if I can
    db kGROUP3,kDiaM,kMode,0            ; m => MODE
    db kGROUP3,kDiaK,kLinkIO,0          ; k => [LINK]       LIST is used more than LINK
    db kGROUP3,kDiaL,kList,0            ; l => [LIST]
    db kGROUP3,kDiaS,kStat,0            ; s => STAT
    db kGROUP3,kDiaT,kTest,0            ; t => [TEST]
    db kGROUP3,kDiaH,kMath,0            ; h => MATH         MODE used more than MATH
    db kGROUP3,kDiaA,kAngle,0           ; a => [ANGLE]
    db kGROUP3,kDiaP,kPrgm,0            ; p => PRGM
    db kGROUP3,kDiaR,kPrgm,0            ; r => PRGM         PRGM has two mappings - P and R (P=name, R=easy)
    db kGROUP3,kDiaD,kDraw,0            ; d => [DRAW]
    db kGROUP3,kDiaV,kVars,0            ; v => VARS
    db kGROUP3,kDiaI,kDist,0            ; i => [DISTR]      DRAW is used more
    db kGROUP3,kDiaX,kMatrix,0          ; x => [MATRX]      MODE is used more
    db kGROUP3,kDiaZ,kClear,0           ; z => CLEAR        for one-handed clearing
    db kGROUP3,kDiaE,kMem,0             ; e => [MEM]        MODE used more
    db kGROUP3,kDiaW,kAns,0             ; w => Ans          I think one-handed wins over logic ([]-A)
    db kGROUP3,kDiaC,kCatalog,0         ; c => [CATALOG]    *MUCH* easier to hit than <>-'
    db kGROUP3,kDiaEnter,kSolve,0       ; enter => solve


    ; PART THREE: OUR CUSTOM SQUARE KEYS
    ; I arbitrarily picked the [] keys to be the token keys

    ; this first group are keys already on the keypad
    db kGROUP3,kSqrEnter,kLastEnt,0         ; enter => last entry
    db kGROUP3,kSqrP,kPi,0                  ; p => pi
    db kGROUP3,kSqrS,kSin,0                 ; s => sin
    db kGROUP3,kSqrD,kCos,0                 ; d => cos
    db kGROUP3,kSqrF,kTan,0                 ; f => tan
    db kGROUP3,kSqrX,kASin,0                ; x => sin^-1
    db kGROUP3,kSqrC,kACos,0                ; c => cos^-1
    db kGROUP3,kSqrV,kATan,0                ; v => tan^-1
    db kGROUP3,kSqrI,kInv,0                 ; i => ^-1
    db kGROUP3,kSquareT,kSquare,0           ; t => ^2           kSquareT since kSqrt is square-root
    db kGROUP3,kSqrR,kSqrt,0                ; r => square-root
    db kGROUP3,kSqrBkSlash,kI,0             ; \ => imaginary        ( | is on the \ key)
    db kGROUP3,kSqrE,kEE,0                  ; e => EE
    db kGROUP3,kSqrLBrack,kCONSTeA,0        ; [ => Euler's number   ( [ is next to p=pi the other constant)
    db kGROUP3,kSqrL,kLog,0                 ; l => log
    db kGROUP3,kSqrN,kExp,0                 ; n => ln               (natural log)
    db kGROUP3,kSqr1,kL1A,0                 ; 1 => L1
    db kGROUP3,kSqr2,kL2A,0                 ; 2 => L2
    db kGROUP3,kSqr3,kL3A,0                 ; 3 => L3               you *can* get this through the list menu
    db kGROUP3,kSqr4,kL4A,0                 ; 4 => L4               if they exist
    db kGROUP3,kSqr5,kL5A,0                 ; 5 => L5
    db kGROUP3,kSqr6,kL6A,0                 ; 6 => L6

    ; this second group are tokens that I find useful that aren't on the keypad
    db kGROUP3,kSqrA,kExtendEcho,kAbs       ; a => abs
    db kGROUP3,kSqrDel,kExtendEcho,kXRoot   ; del => x-root
    db kGROUP3,kSqrPgUp,kExtendEcho,kCbRt   ; pgup => cube-root
    db kGROUP3,kSqrPgDn,kExtendEcho,kCube   ; pgdn => ^3
    db kGROUP3,kSqrEquals,kSolveRoot,0      ; = => solver
    db kGROUP3,kSqrZ,kStd,0                 ; z => ZoomStandard
    db kGROUP3,kSqrRBrack,kListName,0       ; ] => list L
    db kGROUP3,kSqr0,kTheta,0               ; 0 => theta            since it looks similar
    db kGROUP3,kSqr8,kExtendEcho,kmRad      ; 8 => Radian
    db kGROUP3,kSqr9,kExtendEcho,kmDeg      ; 9 => Degree
    db kGROUP3,kSqrG,kExtendEcho2,kGarbageC ; g => GarbageCollect

    ; PART FOUR: OTHER KEYS ON THE KEYBOARD
    db kGROUP3,kShftTab,kRecall,0           ; shift-tab => Rcl _

    ; PART FIVE: KEYPAD KEYS
    ; I don't use these keys often enough that I can go through the
    ; catalog when I need them
    ; If you don't like having keys not perform as marked then remove these lines
    db kLog,0,kSqrt,0                      ; log => square-root
    db kALog,0,kExtendEcho,kXRoot          ; 10^x => x-root
    db kLn,0,kExtendEcho,kCube             ; ln => ^3
    db kExp,0,kExtendEcho,kCbRt            ; e^x => cube-root


;;;; Leave this label!
keyEndMappings:

;;;;;;;; THIS IS WHY ALL FOUR BYTES ARE IMPORTANT, NOT JUST SO IT DOESN'T
;;;;;;;;    GET CONFUSED AND USE THE WRONG VALUES, BUT SO IT KNOWS HOW
;;;;;;;;    MANY VALUE SETS THERE ARE.
;;;;;;;; Do NOT edit this line:
keyNumMappings equ (keyEndMappings - keyMappings) / 4

