; ShortCut v0.7
; (C) 2003-2004 Andy Janata.
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
; Subroutines file -- Various sources

; in: none
; out: curRow += 1, scrolls if needed, curCol = 0
PutSNL: B_CALL NewLine

; in: (hl) = null-terminated string to display
;		 $D6 = new line
; out: displays the text on the screen, curRow and curCol affected
PutS:   ld a,(hl)
    inc hl
    or a
    ret z
    cp 0D6h
    jr z,PutSNL
    B_CALL PutC
    jr PutS

; in: none, but address to callback is labeled RawkeyHook
; out: hook installed
InstallRawKeyHook:
    call LoadAppVar
    res 1,(hl)                  ; We need to do it here ... just because
    bit rawKeyHookActive,(iy+rawKeyHookFlag)
    ld hl,rawKeyHookPtr+2
;    ld de,RawKeyStr
    call CheckHook
    ret nz
;  di
;  halt
    in a,(6)
    ld hl,RawkeyHook
    B_CALL EnableRawKeyHook
    set keybReportAll,(iy+keybFlags)

        ; NEW: Set the installed bit in the Appvar and reset the chaining bit
    call LoadAppVar
    ex de,hl
    set 0,(hl)      ; set installed
    ;res 1,(hl)      ; res chain
    
    call ClrScrn
    InvOn
    Echo mainMenu
    InvOff
    Echo hookText
    Echo hookInstalled
    b_call NewLine
    Echo pressKey
    b_call GetKey

    ret

; in: (hl) = page byte of hook adress
;		(de) = db "Rawkey Hook", 0
; I ought to recode this
CheckHook:
    ret z
    in a,(6)
    cp (hl)
    ret z
;    ex de,hl
;    call PutS
;    ld hl,InUseStr
;    call PutS

; in use:
    call ClrScrn
    InvOn
    Echo mainMenu
    InvOff
    Echo hookText
    Echo hookExists
CheckHookOverLoop:
    b_call GetKey
    cp k1
    jr z,CheckHookOverDoIt
    cp k2
    jr z,CheckHookOverChain
    cp k3
    jr nz,CheckHookOverLoop
    call ClrScrn
    InvOn
    Echo mainMenu
    InvOff
    Echo notInstalled
    Echo pressKey
    b_call GetKey
    pop hl                          ; we were called
    jp drawMenu
    ret
CheckHookOverDoIt:
    xor a       ; set z flag
    ret
CheckHookOverChain:
        ; NEW: Chain to current hook
    call LoadAppVar
    ld hl,(rawKeyHookPtr)       ; the current address
    ld a,(rawKeyHookPtr+2)      ; the current page
    ex de,hl
    set 0,(hl)          ; installed
    set 1,(hl)          ; chain
    inc hl
    ld (hl),a
    inc hl
            ;ld (hl),de         This is what I'm trying to do, but have to do the long way:
    ld (hl),e
    inc hl
    ld (hl),d
    xor a
    ret


CheckHookLoop:
    res onInterrupt,(iy+onFlags)
    B_CALL GetKey
    sub k1
    jr c,CheckHookLoop
    jr z,CheckHookOK
    cp 3
    jr nc,CheckHookLoop
    rra
    ccf
CheckHookOK:
    push af
    call ClrScrn
    pop af
    ret

; load and create the appvar if needed
LoadAppVar:
    call Mov66OPTemp
    call LoadAppVar_Main
    push de
    call Mov66TempOP
    pop de
    ret

LoadAppVar_Create:
    ld hl,appVarDefLen
    push hl
    B_CALL CreateAppVar
    inc de
    inc de
    ld hl,appVarDef
    pop bc
    ldir
    jr LoadAppVar
LoadAppVar_Unarch:
    B_CALL Arc_Unarc
LoadAppVar_Main:
    ld hl,appVarName
    rst rMov9ToOP1
    B_CALL ChkFindSym
    jr c,LoadAppVar_Create
    ld a,b
    or a
    jr nz,LoadAppVar_Unarch
    push hl
    inc de
    inc de
    ld hl,appVarSig
    ld b,appVarSigLen
    call CompStrsN
    pop hl
;    inc de          ;
;    inc de          ; ADJUST THESE AS THE FIXED LENGTH CHANGES !!
;    inc de          ; (length of the header)
;    inc de
    ret z
    ld a,E_Duplicate    ; DUPLICATE error; we simply don't know how to
    B_CALL JError      ; handle this situation

Mov66OPTemp:
    ld hl,OP1
    ld de,tempLoadingOPs
    jr Mov66
Mov66TempOP:
    ld hl,tempLoadingOPs
    ld de,OP1
Mov66:  call Mov11
    call Mov11
    call Mov11
    call Mov11
    call Mov11
    jp Mov11

;;; Similar in theory to the above, but this is for rawkeyhook use
LoadAppVar_RKH:
    ld de,tempLoadingOPs
    call Mov11FrOP1
    ld hl,appVarName
    rst rMov9ToOP1
    B_CALL ChkFindSym
    push af
    push bc
    push de
    push hl
    ld hl,tempLoadingOPs
    rst rMov9ToOP1
    pop hl
    pop de
    pop bc
    pop af
    ret c
    ld a,b
    or a
    scf
    ret nz                  ; ret if archived
    push hl
    inc de
    inc de
    ld hl,appVarSig
    ld b,appVarSigLen
    call CompStrsN
    pop hl
;    inc de
;    inc de          ; ADJUST ME !!!!
;    inc de
;    inc de
    ret z
    scf
    ret

ClrScrn:
    ld hl,0
    ld (curRow),hl		; also curCol = 0
    ld b,128				; 16*8 (cols * rows)
ClrScrnLoop:
    ld a,' '
    B_CALL PutC
    djnz ClrScrnLoop
    ld hl,0
    ld (curRow),hl		; top left corner
    ret

; in: (de) = string 1
;		(hl) = string 2
;		b = length to compare
; out: z if same, nz if not
CompStrsN:
    ld a,(de)
    cp (hl)
    ret nz
    inc de
    inc hl
    djnz CompStrsN
    ret

; in: (de) = dest
;		(hl) = source
; out: copies	 
Mov11FrOP1:
    ld hl,OP1
;    jr Mov11
Mov11:  ldi
    ldi
Mov9:   ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ldi
    ret

; delays for the LCD driver
_lcd_busy_:
    PUSH AF
    INC HL
    DEC HL
    POP AF
    RET
    
_lcd_busy_2:
    PUSH AF
    CALL 000Bh   ;LCD_BUSY_QUICK ; = 000Bh
    POP AF
    RET

invON:
    set textInverse,(iy+textFlags)
    ret

invOFF:
    res textInverse,(iy+textFlags)
    ret

; in: b = number of loops to wait
;       in units of interrupt times (about 200/second)
;       so b=200 is about 1 second
; out: b = 0
; side effects: if a Silver is in fast mode, this gets done 2.5 times faster
;       but then again, I think it has the same interrupt rate
wait_b:
    ei
wait_b_loop:
    halt
    djnz wait_b_loop
    ret

; jumps to a location on another ROM page
; in:   hl: address
;       a:  page
doRomJump:
    push hl     ; save it since we trash it for loading it
    ld hl,romJump_START
    ld de,saveSScreen               ; JMan says 8000h might be better
    ldi         ;  \
    ldi         ;   \
    ldi         ;    +- only 6 bytes, ldir is smaller but this is faster
    ldi         ;   /
    ldi         ;  /
    ldi         ; /
    pop hl
    jp saveSScreen

romJump_START:    
    out (pagePort),a
    ld a,(saveAccumulator)          ; restore a to the key code
    jp (hl)
romJump_END:

